package com.engine.organization.entity.comp.bo;

import com.engine.organization.entity.comp.dto.CompListDTO;
import com.engine.organization.entity.comp.po.CompPO;
import org.apache.commons.collections.CollectionUtils;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @description: TODO
 * @author:dxfeng
 * @createTime: 2022/05/16
 * @version: 1.0
 */
public class CompBO {
    public static List<CompListDTO> buildCompDTOList(Collection<CompPO> list) {
        if (CollectionUtils.isEmpty(list)) {
            return Collections.emptyList();
        }
        List<CompListDTO> dtoList = list.stream().map(e -> CompListDTO.builder()
                .id(e.getId())
                .compNo(e.getCompNo())
                .compName(e.getCompName())
                .compNameShort(e.getCompNameShort())
                .parentCompany(e.getParentCompany())
                .orgCode(e.getOrgCode())
                .industry(e.getIndustry())
                .compPrincipal(e.getCompPrincipal())
                .description(e.getDescription())
                .forbiddenTag(e.getForbiddenTag())
                .build()
        ).collect(Collectors.toList());
        Map<Long, List<CompListDTO>> collects = dtoList.stream().filter(item -> null != item.getParentCompany() && 0 != item.getParentCompany()).collect(Collectors.groupingBy(CompListDTO::getParentCompany));
        return dtoList.stream().filter(item -> null == item.getParentCompany() || 0 == item.getParentCompany()).map(e -> {
            e.setChildren(collects.get(e.getId()));
            return e;
        }).collect(Collectors.toList());
    }

}
